{%- from "runtest/map.jinja" import tempest with context %}
{%- if tempest.get('enabled', False) -%}

tempest_config_dir:
  file.directory:
  - name: {{ tempest.cfg_dir }}
  - makedirs: true
  - mode: 755

tempest_config_file:
  runtest.tempestconf_present:
    - name: {{ tempest.cfg_dir }}/{{ tempest.cfg_name }}
    - regenerate: {{ tempest.regenerate_conf }}
    - require:
      - file: tempest_config_dir

  {%- if tempest.test_target is defined %}
create_on_target:
  salt.function:
    - tgt: {{ tempest.test_target }}
    - tgt_type: compound
    - name: file.mkdir
    - arg:
      -  {{ tempest.cfg_dir }}

copy_to_target:
  cmd.run:
    - name: salt-cp {{ tempest.test_target }} {{ tempest.cfg_dir }}/{{ tempest.cfg_name }} {{ tempest.cfg_dir }}/{{ tempest.cfg_name }}
    - require:
      - salt: create_on_target

mine_send_keystonerc_file:
  salt.function:
    - tgt: 'I@keystone:server and *01*'
    - tgt_type: compound
    - name: mine.send
    - arg:
      - 'keystonerc_file'
      - 'mine_function=cmd.shell'
      - 'cat {{ tempest.keystonerc }}'

    {%- if tempest.put_keystone_rc_enabled %}
put_keystone_rc_file:
  salt.state:
    - tgt: {{ tempest.test_target }}
    - tgt_type: compound
    - sls: runtest.put_keystone_file
    - concurrent: true
    - require:
      - salt: mine_send_keystonerc_file
    {%- endif %}

    {%- if tempest.put_local_image_file_enabled %}
put_local_image_file:
  salt.state:
    - tgt: {{ tempest.test_target }}
    - tgt_type: compound
    - sls: runtest.put_local_image_file
    - concurrent: true
    - pillar: {{ pillar }}
    - require:
      - tempest_config_file
    {# Sometimes this task hangs infinitely when using salt 2017.7.0 #}
      {%- if salt['grains.get']('saltversion') >= '2017.7.0' %}
    - retry:
        attempts: 3
        until: True
        interval: 10
      {%- endif %}
    {%- endif %}

  {%- endif %}

{%- endif -%}
